#include <QCoreApplication>
#include <QApplication>
#include <QDebug>
#include <QTimer>
#include <QFileInfo>

#include "message_handler.h"

#include "interfaces.h"
#include "DCPlugin/include/hwapi.h"

#include <unistd.h>
#include <thread>
#include <memory>
#include <QSharedMemory>
#include <QRunnable>
#include <QThreadPool>

#include "update.h"

#ifdef PTU5
#define SERIAL_PORT "ttymxc2"
#else
#define SERIAL_PORT "ttyUSB0"
#endif

class Work : public QRunnable {
    QString m_update_ctrl_file;
public:
    explicit Work(QString update_ctrl_file)
        : m_update_ctrl_file(update_ctrl_file) {}
    void run() {
        Update m_update(m_update_ctrl_file);
        m_update.doUpdate();
    }
};

// argv[1]: file to send to dc
int main(int argc, char *argv[]) {
    QApplication a(argc, argv);

    if (!messageHandlerInstalled()) { // change internal qt-QDebug-handling
        atbInstallMessageHandler(atbDebugOutput);
        setDebugLevel(QtMsgType::QtDebugMsg);
        //setDebugLevel(QtMsgType::QtDebugMsg);
    }

    QString update_ctrl_file = "/opt/app/tools/atbupdate/update_log.csv";
    if (argc == 2) {
        update_ctrl_file = argv[1];
    }
    qInfo() << "Using" << update_ctrl_file << "as update logfile";

    Work work(update_ctrl_file);
    work.setAutoDelete(false);
    QThreadPool *threadPool = QThreadPool::globalInstance();
    threadPool->start(&work);
    if (!threadPool->waitForDone()) {
        return -1;
    }
    return 0;
}
